<?php 
if ( !defined('PHPWG_ROOT_PATH') )
  define('PHPWG_ROOT_PATH','../../');

include_once( PHPWG_ROOT_PATH.'include/common.inc.php' );

if (!isset($rvm_dir))
  access_denied( 'Plugin not installed' );

include_once( dirname(__FILE__) .'/include/functions_map.php');
include_once( dirname(__FILE__) .'/include/functions.php');


set_make_full_url();

$rewritten = '';
foreach (array_keys($_GET) as $key)
{
  $rewritten = $key;
  break;
}
// deleting first "/" if displayed
$tokens = explode(
  '/',
  preg_replace('#^/#', '', $rewritten)
  );
$next_token = 0;
$result = rvm_parse_kml_url($tokens, $next_token);
$page = array_merge( $page, $result );
$where_sql = rvm_bounds_to_sql( $page['box'] );
$where_sql .= get_sql_condition_FandF(
      array
        (
          'forbidden_categories' => 'category_id',
          'visible_categories' => 'category_id',
          'visible_images' => 'i.id'
        ),
      "\n  AND"
  );

$img_fields = ' i.id,i.tn_ext,i.name,i.comment,i.path,i.lat,i.lon';
 
$was_flat = @$page['flat'];
$page['flat']=true;
build_section_items($img_fields, $where_sql, true);
if (!$was_flat) unset($page['flat']);

/*header('Cache-Control: public' );
header('Expires: '.gmdate('D, d M Y H:i:s', time()+600).' GMT');
header('Pragma:');*/
header('Content-Type: text/plain; charset='.$lang_info['charset']);

$clusters = array();
$cluster_debug = '';
if ( !empty($page['items']) )
{
  $gm_config = rvm_get_config();
  include_once( dirname(__FILE__) .'/include/cluster_maker.php');
  $cm = new ClusterMaker( $page['items'] );
  $clusters = $cm->make_clusters(
      isset($_GET['lap']) ? $_GET['lap'] : 0.01,
      isset($_GET['lop']) ? $_GET['lop'] : 0.01,
      isset($_GET['n']) ? $_GET['n'] : $gm_config['nb_markers']
    );
  $cluster_debug .= ' cluster: '. $cm->debug_str. ';';
}

function jsgm_position( $position )
{
  return 'new GLatLng(' . $position['lat'] . ',' . $position['lon'] . ')';
}

function jsgm_bounds( $bounds )
{
  return 'new GLatLngBounds(' . jsgm_position(bounds_sw($bounds)) . ',' . jsgm_position(bounds_ne($bounds)) . ')';
}

function jsgm_str( $str )
{
  return '"'. str_replace(array("\\",'"',"/","\n","\r","\t"), array("\\\\",'\"',"\\/","\\n","\\r","\\t"), $str) .'"';
}

$out = '';

$out .= '{';

$out .= "\ntitle: ".jsgm_str( strip_tags($page['title']) );
$out .= ",\n";

$out .= "page_url: ".jsgm_str( duplicate_index_url( array('start'=>0) ) );
$out .= ",\n";

$out .= "blowup_url: ".jsgm_str( rvm_duplicate_blowup_url( array('start'=>0) ) );
$out .= ",\n";

$out .= "kml_url: ".jsgm_str( rvm_duplicate_kml_index_url( array('start'=>0, 'flat'=>1) ) );
$out .= ",\n";

$out .= "nb_items: ".count($page['items']);
$out .= ",\n";

$out .= "bounds: ";
if ( isset($cm) )
  $out .= jsgm_bounds( $cm->_bounds );
else
  $out .= "null";
$out .= ",\n";


$out .= "\nimage_clusters: [\n";
$i=0;
foreach( $clusters as $c )
{
  if ($i) $out .= ",\n\n";
  $out .= "{";
  $out .= 'position: '. jsgm_position( bounds_center($c['bounds']) );
  $out .= ",\n";
  $out .= 'nb_items: '.count($c['items']);
  $out .= ",\n";

  $out .= 'blowup_url: "'.rvm_duplicate_blowup_url(array('box'=>$c['bounds']), array('start') ). '"';
  $out .= ",\n";

  $out .= 'kml_url: "'.rvm_duplicate_kml_index_url(array('box'=>$c['bounds'], 'flat'=>1), array('start') ). '"';
  $out .= ",\n";

  $out .= 'items: [';
  for ($j=0; $j<count($c['items']); $j++)
  {
    $img = $page['items'] [ $c['items'][$j] ];
    $img['file'] = basename( $img['path'] );
    if (!empty( $img['name'] ) )
      $title = $img['name'];
    else
      $title = str_replace('_', ' ', get_filename_wo_extension($img['file']));

    $params = array(
        'image_id' => $img['id'],
        'image_file' => $img['file'],
        'flat' => 1,
      );
    $page_url = duplicate_picture_url($params, array('start') );

    if ($j) $out .= ",";
    $out .= "{";
    $out .= "tn: ".jsgm_str( get_thumbnail_url( $img ) );
    $out .= ",";
    $out .= "name: ".jsgm_str( $title );
    $out .= ",";
    $out .= "comment: ".jsgm_str( $img['comment'] );
    $out .= ",";
    $out .= "page_url: ".jsgm_str( $page_url );
    $out .= "}";
  }
  $out .= ']';
  $out .= "\n";
  $out .= "}";
  $i++;
}
$out .= "] /*clusters*/\n";

if ($conf['show_gt'])
{
  $time = get_elapsed_time($t2, get_moment());
  $page['queries_time'] = number_format($page['queries_time'],3,'.',' ');
  $out .= "\n,debug: '$time;$cluster_debug queries:".$page['count_queries']." in ".$page['queries_time']." s'\n";
}

$out .= '}';
echo $out;
?>
